"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("lodash"));
const indexOfClosingBracket = (tokens) => {
    let openedBrackets = 0;
    for (let i = 0; i < tokens.length; i++) {
        const isFirstToken = i === 0;
        const token = tokens[i];
        switch (token) {
            case "(":
                openedBrackets++;
                break;
            case ")":
                openedBrackets--;
                if (!isFirstToken && openedBrackets === 0) {
                    return i;
                }
                break;
        }
    }
    return -1;
};
exports.untilClosingBracket = (tokens) => {
    const closingIndex = indexOfClosingBracket(tokens);
    return tokens.slice(0, closingIndex + 1);
};
exports.withoutEnclosingBrackets = (tokens) => {
    if (_.first(tokens) === "(" && _.last(tokens) === ")") {
        return _.tail(_.initial(tokens));
    }
    return tokens;
};
exports.generateAST = (tokens) => {
    const result = [];
    for (let i = 0; i < tokens.length; i++) {
        const token = tokens[i];
        switch (token) {
            case "(":
                const remainder = tokens.slice(i);
                const lengthOfSubExpression = indexOfClosingBracket(remainder);
                const endOfSubExpression = i + lengthOfSubExpression;
                const subExpressionWithEnclosingBrackets = tokens.slice(i, endOfSubExpression + 1);
                const subExpression = exports.withoutEnclosingBrackets(subExpressionWithEnclosingBrackets);
                i = endOfSubExpression;
                result.push(exports.generateAST(subExpression));
                break;
            default:
                result.push(token);
                break;
        }
    }
    return result;
};
exports.generateASTs = (tokens) => {
    const result = [];
    for (let i = 0; i < tokens.length; i++) {
        const token = tokens[i];
        if (token === "(") {
            const remainder = tokens.slice(i);
            const lengthOfSubExpression = indexOfClosingBracket(remainder);
            const endOfSubExpression = i + lengthOfSubExpression;
            const subExpressionWithEnclosingBrackets = tokens.slice(i, endOfSubExpression + 1);
            const subExpression = exports.withoutEnclosingBrackets(subExpressionWithEnclosingBrackets);
            i = endOfSubExpression;
            result.push(exports.generateAST(subExpression));
        }
    }
    return result;
};
