"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Tokenizer_1 = require("./Tokenizer");
const ASTGenerator_1 = require("./ASTGenerator");
const Runtime_1 = require("./Runtime");
function interpret(program) {
    const tokens = Tokenizer_1.tokenize(program);
    const asts = ASTGenerator_1.generateASTs(tokens);
    const results = asts.map(ast => Runtime_1.execute(ast));
    return results;
}
exports.interpret = interpret;
exports.numLisp = (code, ...vars) => {
    if (vars.length) {
        throw new Error("Only use literals, please.");
    }
    return interpret(code[0]);
};
