"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Interpreter_1 = require("./Interpreter");
describe("Interpreter", () => {
    test.each `
  given                                   | expected
  ${"(+ 1 2)"}                            | ${[3]}
  ${"(- 1 2)"}                            | ${[-1]}
  ${"(+ (+ 1 2) 3)"}                      | ${[6]}
  ${"(list 1 2 3)"}                       | ${[[1, 2, 3]]}
  ${"(cons 1 (list 2 3))"}                | ${[[1, 2, 3]]}
  ${"( + 10 ( car ( list 32 33 34 ) ) )"} | ${[42]}
  `("$interpret($given)=$expected", ({ given, expected }) => {
        expect(Interpreter_1.interpret(given)).toEqual(expected);
    });
});
