"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Globals_1 = require("./Globals");
/**
 *
 * @param ast
 * @param globals is mutated!
 */
function execute(ast, globals = Globals_1.defaultGlobals) {
    const [funcRef, ...args] = ast;
    const func = typeof funcRef === "string" ? globals[funcRef] : execute(funcRef, globals);
    const argsToPass = args.map(a => typeof a === "string" ? a : execute(a, globals));
    const result = func(argsToPass, globals);
    return result;
}
exports.execute = execute;
