"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Tokenizer_1 = require("./Tokenizer");
describe("tokenize", () => {
    test.each `
    given   | expected
    ${""}   | ${[]}
    ${"()"} | ${["(", ")"]}
    ${"(list a b c)"} | ${["(", "list", "a", "b", "c", ")"]}
    ${"(define (reduce a b) (+ a b))"} | ${["(", "define", "(", "reduce", "a", "b", ")", "(", "+", "a", "b", ")", ")"]}
  `('tokenize($given) ~= $expected', ({ given, expected }) => {
        expect(Tokenizer_1.tokenize(given)).toEqual(expected);
    });
});
describe("splitMultiple", () => {
    describe("when given only '(' to split", () => {
        it("acts normally", () => {
            expect(Tokenizer_1.splitMultiple("(")("( ab ce ) ( dasde")).toEqual(["(", " ab ce ) ", "(", " dasde"]);
        });
    });
});
